// EditorDoc.cpp : implementation file
//

#include "stdafx.h"
#include "postman.h"
#include "EditorDoc.h"
#include "EditorView.h"
#include "AuxFrame.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditorDoc

IMPLEMENT_DYNCREATE(CEditorDoc, CDocument)

CEditorDoc::CEditorDoc()
{

}

BOOL CEditorDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	return TRUE;
}

CEditorDoc::~CEditorDoc()
{

}


BEGIN_MESSAGE_MAP(CEditorDoc, CDocument)
	//{{AFX_MSG_MAP(CEditorDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditorDoc diagnostics

#ifdef _DEBUG
void CEditorDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CEditorDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEditorDoc serialization

void CEditorDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		//Reading file
		CFile* pFile = ar.GetFile();
		ASSERT(pFile->GetPosition() == 0);
		FileName = pFile->GetFilePath();

		DWORD nFileSize = pFile->GetLength();
		CEditorView* View = (CEditorView*)m_viewList.GetHead();
		CAuxFrame * FrameWindow = ( CAuxFrame * ) View->GetParentFrame();
		#ifdef _DEBUG
			FrameWindow->AssertValid();
		#endif
		char * pData = new char[nFileSize + 1 ];
		BOOL Header = TRUE;
		pFile->Read(pData, nFileSize );
		pData[nFileSize] = 0;
		CString Line;
		CString Message;
		
		for( DWORD i = 0; i < nFileSize ; i++ )
		{
			Line += pData[i];
			if( pData[i] == '\r' && pData[i+1] == '\n' )
			{
				i++;
				Line += pData[i];
				if( Header )
				{
					if( Line.GetLength() == 2 )
					{
						Header = FALSE;
					}
					else
					{
						if( Line[0] == 'S' && !Line.Left(7).CompareNoCase( "Subject" ) )
						{
							Subject = Line.Right( Line.GetLength() - Line.Find(':') - 1 );
							Subject = Subject.Left(Subject.GetLength()-2);
							Subject.TrimLeft();
							Subject.TrimRight();
						}
						else if( Line[0] == 'D' && !Line.Left(4).CompareNoCase("Date" ) )
						{
							Date = Line.Right( Line.GetLength() - Line.Find(':') - 1 );
							Date = Date.Left(Date.GetLength()-2);
							Date.TrimLeft();
							Date.TrimRight();
						}
						else if( Line[0] == 'F' && !Line.Left(4).CompareNoCase("From" ) )
						{
							From = Line.Right( Line.GetLength() - Line.Find(':') - 1 );
							From = From.Left(From.GetLength()-2);
							From.TrimLeft();
							From.TrimRight();

						}
						else if( !Line.Left(2).CompareNoCase("To" ) )
						{
							To = Line.Right( Line.GetLength() - Line.Find(':') - 1 );
							To = To.Left( To.GetLength()-2);
							To.TrimLeft();
							To.TrimRight();
						}
						else if( !Line.Left(2).CompareNoCase("CC" ) )
						{
							CC = Line.Right( Line.GetLength() - Line.Find(':') - 1 );
							CC = CC.Left( CC.GetLength()-2);
							CC.TrimLeft();
							CC.TrimRight();
						}
					}
				}
				else
				{
					if( Line[0] == '.' && Line[1] == '.' )
					{
						Line = Line.Right( Line.GetLength() - 1 );
					}
					Message += Line;
				}
				Line.Empty();
				
			}
		}
		int Len = Message.GetLength();
		if( Len > 4 &&Message[Len-1] == '\n' && Message[Len-2] == '\r' && Message[Len-3] == '.' && Message[Len-4] == '\n' && Message[Len-5] == '\r' )
		{
			Message = Message.Left( Len - 5);
		}
		else if( Len == 3 && Message.Compare(".\r\n") == 0 )
		{
			Message.Empty();
		}
		MailData = Message;
		free( pData );
	}
	UpdateAllViews(NULL);
}

/////////////////////////////////////////////////////////////////////////////
// CEditorDoc commands

CFrameWnd * CEditorDoc::GetFrame()
{
	CView* View = (CView*) m_viewList.GetHead();
	return View->GetParentFrame();
}

CString & CEditorDoc::GetData()
{
	return MailData;
}
