// EditorView.cpp : implementation file
//

#include "stdafx.h"
#include "postman.h"
#include "EditorView.h"
#include "EditorDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditorView

IMPLEMENT_DYNCREATE(CEditorView, CView)

CEditorView::CEditorView()
{
}

CEditorView::~CEditorView()
{
}


BEGIN_MESSAGE_MAP(CEditorView, CView)
	//{{AFX_MSG_MAP(CEditorView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditorView drawing

void CEditorView::OnDraw(CDC* pDC)
{
	#define MARGIN 10
	CEditorDoc* pDoc = (CEditorDoc *) GetDocument();
	CString &Data = pDoc->GetData();
	CString Word;
	CString Line;
	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT));			// clear out structure.
	lf.lfHeight = 120;							// request a 12-pixel-height font
	strcpy(lf.lfFaceName, "Times New Roman");	// face name 
	CFont Font;
	Font.CreatePointFontIndirect(&lf, pDC);

	pDC->SelectObject( &Font );
	RECT Rect, WordRect= { 0,0,0,0 }, DrawRect;
	int Height = MARGIN, Width = MARGIN;
	GetWindowRect( &Rect );
	Rect.right = Rect.right - Rect.left - MARGIN;
	Rect.left = MARGIN;
	Rect.bottom = Rect.bottom - Rect.top - MARGIN;
	Rect.top = MARGIN;
	int Length = Data.GetLength();
	for( int i = 0; i < Length ; i++ )
	{

		if( i+1 == Length || Data[i] == ' ' || Data[i] == 0 || Data[i] == '\t' || Data[i] == '\r' || Data[i] == '\n')
		{
			if( Data[i] == '\t' )
				Word += "        ";
			else if( i+1 == Length || Data[i] == ' ' )
				Word += Data[i];
			
			//Got a word...
			pDC->DrawText( Word, &WordRect, DT_CALCRECT );
			//Can the word be drawn on the line?
			if( WordRect.right + Width < Rect.right )
			{
				DrawRect.left = Width;
				DrawRect.right = WordRect.right + Width;
				DrawRect.top = Height;
				DrawRect.bottom = WordRect.bottom + Height;
				Width += WordRect.right;
			}
			else
			{
				DrawRect.left = MARGIN;
				DrawRect.right = WordRect.right + MARGIN;
				Height += WordRect.bottom;
				DrawRect.top = Height;
				DrawRect.bottom = WordRect.bottom + Height;
				Width = WordRect.right + MARGIN;
			}
			pDC->DrawText( Word, &DrawRect, DT_LEFT );
			Word.Empty();
			if( Data[i] == '\r' || Data[i] == '\n')
			{
				if( Data[i] == '\r' && Data[i+1] == '\n' )
				{
					i++;
				}
				Height += WordRect.bottom;
				Width = MARGIN;
				
			}
		}
		else
			Word += Data[i];
	}
}

/////////////////////////////////////////////////////////////////////////////
// CEditorView diagnostics

#ifdef _DEBUG
void CEditorView::AssertValid() const
{
	CView::AssertValid();
}

void CEditorView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEditorView message handlers
