// HeaderList.cpp: implementation of the CHeaderList class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "postman.h"
#include "HeaderList.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CHeaderList::CHeaderList()
{
	Start = NULL;
}

CHeaderList::~CHeaderList()
{

}

void CHeaderList::GetHeader(CString &UID, CString &Header)
{
	HeaderInfo * TempHeader;
	for( TempHeader = Start; TempHeader != NULL; TempHeader = TempHeader->Next )
	{
		if( TempHeader->UID == UID )
		{
			Header = TempHeader->Header;
			TempHeader->Touched = TRUE;
			return;
		}
	}
	Header.Empty();
}

HeaderInfo * CHeaderList::AddHeader(CString &UID, CString &Header)
{
	HeaderInfo * NewHeader;
	NewHeader = new HeaderInfo;
	NewHeader->Header = Header;
	NewHeader->UID = UID;
	NewHeader->Next = Start;
	NewHeader->Touched = TRUE;
	Start = NewHeader;
	return NewHeader;
}

void CHeaderList::RemoveAll()
{
	// Will do this later...
}

void CHeaderList::ReadHeaders(CString &Folder)
{
	CString Header, UID; 
	WORD UIDLength, HeaderLength;
	char * Buffer;
	if( Folder[ Folder.GetLength() - 1 ] != '\\' )
		Folder += '\\';
	HDRFileName = Folder + "Headers.hdr";
	int count = 0;
//	RemoveAll();
	CFile File;
	if( !File.Open( HDRFileName, CFile::modeRead ) )
		return;
	while( 1 )
	{
		if( !File.Read( & UIDLength, sizeof( WORD ) ) )
			break;
		Buffer = new char[UIDLength];
		File.Read( Buffer, UIDLength );
		UID = Buffer;
		delete Buffer;

		if( !File.Read( & HeaderLength, sizeof( WORD ) ) )
			break;
		Buffer = new char[HeaderLength];
		File.Read( Buffer, HeaderLength );
		Header = Buffer;
		delete Buffer;
		HeaderInfo * NewHeader = AddHeader( UID, Header );
		NewHeader->Touched = FALSE;
		count++;
	}
	File.Close();
	{
		#ifdef _DEBUG
		CString Msg;
		Msg.Format( "%d Headers retrived", count );
		AfxMessageBox( Msg );
		#endif
	}

	/*
	HeaderInfo * TempHeader;
	for( TempHeader = Start; TempHeader != NULL; TempHeader = TempHeader->Next )
	{
		TempHeader->Touched = FALSE;
	}
	*/
}


void CHeaderList::UpdateHeaders( BOOL CheckTouched)
{

	CFile File;
	HeaderInfo * TempHeader;
	WORD UIDLength, HeaderLength;
	if( !File.Open( HDRFileName, CFile::modeCreate | CFile::modeWrite ) )
		return;
	int Saved = 0;
	int Skipped = 0;
	for( TempHeader = Start; TempHeader != NULL; TempHeader = TempHeader->Next )
	{
		if( !CheckTouched || TempHeader->Touched )
		{
			UIDLength = TempHeader->UID.GetLength() + 1;
			HeaderLength = TempHeader->Header.GetLength() + 1;
	
			File.Write( & UIDLength, sizeof( WORD ) );
			File.Write( (LPCSTR)TempHeader->UID, UIDLength);
			File.Write( & HeaderLength, sizeof( WORD ) );
			File.Write( (LPCSTR)TempHeader->Header, HeaderLength);
			Saved++;
		}
		else
			Skipped++;
	}
	
	File.Close();
	
	{
		#ifdef _DEBUG
		CString Msg;
		Msg.Format( "%d saved\r\n%d skipped", Saved, Skipped );
		AfxMessageBox( Msg );
		#endif
	}
	
}
