// MailDoc.cpp : implementation file
//

#include "stdafx.h"
#include "postman.h"
#include "MailDoc.h"
#include "AuxFrame.h"
#include "MainFrm.h"
#include "TreePane.h"
#include "OutboxWarning.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CPostmanApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CMailDoc

IMPLEMENT_DYNCREATE(CMailDoc, CDocument)

CMailDoc::CMailDoc()
{
	Compose = FALSE;
}

BOOL CMailDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	return TRUE;
}

CMailDoc::~CMailDoc()
{
	theApp.PostThreadMessage( WM_USER+1, ID, 0);

//	theApp.OnCloseDocument( ID );
}


BEGIN_MESSAGE_MAP(CMailDoc, CDocument)
	//{{AFX_MSG_MAP(CMailDoc)
	ON_COMMAND(IDM_SAVE, OnSave)
	ON_UPDATE_COMMAND_UI(IDM_SAVE, OnUpdateSave)
	ON_EN_CHANGE(IDC_TO_RW, OnChangeTo)
	ON_EN_CHANGE(IDC_SUBJECT_RW, OnChangeSubject)
	ON_EN_CHANGE(IDC_CC_RW, OnChangeCC)
	ON_EN_CHANGE(IDC_FROM_RW, OnChangeFrom)
	ON_COMMAND(IDM_SEND_TO_OUTBOX, OnSendToOutbox)
	ON_UPDATE_COMMAND_UI(IDM_SEND_TO_OUTBOX, OnUpdateSendToOutbox)
	ON_COMMAND(IDM_SAVE_AS, OnSaveAs)
	ON_UPDATE_COMMAND_UI(IDM_SAVE_AS, OnUpdateSaveAs)
	ON_COMMAND(IDM_REPLY, OnReply)
	ON_UPDATE_COMMAND_UI(IDM_REPLY, OnUpdateReply)
	ON_COMMAND(IDM_REPLY_ALL, OnReplyAll)
	ON_UPDATE_COMMAND_UI(IDM_REPLY_ALL, OnUpdateReplyAll)
	ON_COMMAND(IDM_FORWARD, OnForward)
	ON_UPDATE_COMMAND_UI(IDM_FORWARD, OnUpdateForward)
	ON_COMMAND(ID_MANU, OnManu)
	ON_UPDATE_COMMAND_UI(ID_MANU, OnUpdateManu)
	ON_COMMAND(ID_VINU, OnVinu)
	ON_UPDATE_COMMAND_UI(ID_VINU, OnUpdateVinu)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMailDoc diagnostics

#ifdef _DEBUG
void CMailDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CMailDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMailDoc serialization

void CMailDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{

	}
	else
	{
		//Reading file
		CFile* pFile = ar.GetFile();
		ASSERT(pFile->GetPosition() == 0);
		FileName = pFile->GetFilePath();

		DWORD nFileSize = pFile->GetLength();
		CEditView* View = (CEditView*)m_viewList.GetHead();
		CEdit &EditCtrl = View->GetEditCtrl();
		CAuxFrame * FrameWindow = ( CAuxFrame * ) View->GetParentFrame();
		#ifdef _DEBUG
			FrameWindow->AssertValid();
		#endif
		char * pData = new char[nFileSize + 1 ];
		BOOL Header = TRUE;
		pFile->Read(pData, nFileSize );
		pData[nFileSize] = 0;
		CString Line;
		CString Message;
		
		for( DWORD i = 0; i < nFileSize ; i++ )
		{
			Line += pData[i];
			if( pData[i] == '\r' && pData[i+1] == '\n' )
			{
				i++;
				Line += pData[i];
				if( Header )
				{
					if( Line.GetLength() == 2 )
					{
						Header = FALSE;
					}
					else
					{
						if( Line[0] == 'S' && !Line.Left(7).CompareNoCase( "Subject" ) )
						{
							Subject = Line.Right( Line.GetLength() - Line.Find(':') - 1 );
							Subject = Subject.Left(Subject.GetLength()-2);
							Subject.TrimLeft();
							Subject.TrimRight();
						}
						else if( Line[0] == 'D' && !Line.Left(4).CompareNoCase("Date" ) )
						{
							Date = Line.Right( Line.GetLength() - Line.Find(':') - 1 );
							Date = Date.Left(Date.GetLength()-2);
							Date.TrimLeft();
							Date.TrimRight();
						}
						else if( Line[0] == 'F' && !Line.Left(4).CompareNoCase("From" ) )
						{
							From = Line.Right( Line.GetLength() - Line.Find(':') - 1 );
							From = From.Left(From.GetLength()-2);
							From.TrimLeft();
							From.TrimRight();

						}
						else if( !Line.Left(2).CompareNoCase("To" ) )
						{
							To = Line.Right( Line.GetLength() - Line.Find(':') - 1 );
							To = To.Left( To.GetLength()-2);
							To.TrimLeft();
							To.TrimRight();
						}
						else if( !Line.Left(2).CompareNoCase("CC" ) )
						{
							CC = Line.Right( Line.GetLength() - Line.Find(':') - 1 );
							CC = CC.Left( CC.GetLength()-2);
							CC.TrimLeft();
							CC.TrimRight();
						}
					}
				}
				else
				{
					if( Line[0] == '.' && Line[1] == '.' )
					{
						Line = Line.Right( Line.GetLength() - 1 );
					}
					Message += Line;
				}
				Line.Empty();
				
			}
		}
		int Len = Message.GetLength();
		if( Len > 4 &&Message[Len-1] == '\n' && Message[Len-2] == '\r' && Message[Len-3] == '.' && Message[Len-4] == '\n' && Message[Len-5] == '\r' )
		{
			Message = Message.Left( Len - 5);
		}
		else if( Len == 3 && Message.Compare(".\r\n") == 0 )
		{
			Message.Empty();
		}
		EditCtrl.SetWindowText( Message );
		free( pData );
	}
}

CFrameWnd * CMailDoc::GetFrame()
{
	CView* View = (CView*) m_viewList.GetHead();
	return View->GetParentFrame();
}

void CMailDoc::SetViewReadOnly(BOOL bReadOnly )
{
	CEditView* View = (CEditView*)m_viewList.GetHead();
	CEdit &EditCtrl = View->GetEditCtrl();
	EditCtrl.SetReadOnly( bReadOnly );

}

BOOL CMailDoc::CanCloseFrame(CFrameWnd* pFrame) 
{
	if( Compose && IsModified() )
	{
		CEditView* View = (CEditView*)m_viewList.GetHead();
		int Ret = View->MessageBox( "This mail hasn't been saved. Want to save it?", "Postman", MB_ICONQUESTION | MB_YESNOCANCEL );
		if( Ret == IDYES )
		{
			OnSave();
		}
		else if( Ret == IDCANCEL )
			return FALSE;
	}
	return TRUE;
}

void CMailDoc::OnSave() 
{

	if( FileName.IsEmpty() )
	{

		CString Path;
		Path = CPostmanApp::AppData + "OutBox";
		CPostmanApp::CreateFolder( Path );
		CPostmanApp::GetTempFileName( FileName, Path );
	}
	SaveFile( FileName , TRUE );
	SetModifiedFlag( FALSE );
	AfxGetMainWnd( )->PostMessage( WM_USER, OUTBOX, 0);
}


void CMailDoc::OnUpdateSave(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( Compose );
}


void CMailDoc::OnSaveAs() 
{
	CEditView* View = (CEditView*)m_viewList.GetHead();
	CFileDialog FileDlg( FALSE, "eml",NULL,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_ENABLESIZING | OFN_EXPLORER,
		"E-Mail Files (*.eml)|*.eml||", View);
	if( FileDlg.DoModal() == IDOK)
	{
		if( !Compose )
		{
			CString Source = GetPathName( );
			CopyFile( Source , FileDlg.GetPathName() );
		}
		else
			SaveFile( FileDlg.GetPathName() );
	}

	
}

void CMailDoc::OnUpdateSaveAs(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
}


BOOL CMailDoc::SaveFile(CString &FileName, BOOL WriteMix)
{
	CFile File;
	CString Message;
	CString Header;

	try
	{
		if( FileName.IsEmpty() || !File.Open( FileName, CFile::modeCreate | CFile::modeWrite ) )
		{
			//AfxMessageBox("Error: Unable to save file...");
			return FALSE;
		}
		
		CEditView* View = (CEditView*)m_viewList.GetHead();
		View->GetWindowText( Message );
		ByteStuff( Message );
		CAuxFrame * FrameWindow = (CAuxFrame * ) GetFrame();
		if( Compose )
		{
			FrameWindow->GetDlgItem( IDC_FROM_RW, From );
			FrameWindow->GetDlgItem( IDC_SUBJECT_RW, Subject );
			FrameWindow->GetDlgItem( IDC_TO_RW, To );
			FrameWindow->GetDlgItem( IDC_CC_RW, CC );
			CPostmanApp::GetDateString( Date );
		}
		//Composing the MIME message
		
		Header	= "Date:" +  Date + "\r\n";
		Header	+= "From: "+ From + "\r\n";
		Header	+= "Subject: "+ Subject + "\r\n";
		Header	+= "To: "+ To + "\r\n";
		if( CC.GetLength() )
			Header	+= "Cc: "+ CC + "\r\n";
		Header	+= "MIME-Version: 1.0\r\nContent-Type: text/plain; charset=iso-8859-1\r\nContent-Transfer-Encoding: 7bit\r\n\r\n";
		Message = Message + "\r\n.\r\n";
		File.Write( (LPCSTR) Header, Header.GetLength() );
		File.Write( (LPCSTR) Message, Message.GetLength() );
		File.Close();
		if( !WriteMix )
			return TRUE;
		//Writing to MIX file
		CMixFile MixData;
		MixData.From = From;
		MixData.To = To;
		MixData.Date = Date;
		MixData.Subject = Subject;
		MixData.FileName = FileName;
		MixData.Size = Message.GetLength() + Header.GetLength();
		MixData.Status = 0;
		MixData.WriteMIX( CString(CPostmanApp::AppData + "OutBox\\Mail Index.mix") );
		


	}
	catch(...)
	{
		return FALSE;
	}
	return TRUE;
}

void CMailDoc::OnChangeSubject() 
{
	CString Subject;
	CAuxFrame * FrameWindow = (CAuxFrame * ) GetFrame();
	SetModifiedFlag( TRUE );
	FrameWindow->GetDlgItem( IDC_SUBJECT_RW, Subject );	
	Subject =  "Postman " +  Subject ;
	FrameWindow->SetWindowText( Subject );
}

void CMailDoc::OnChangeCC() 
{
	SetModifiedFlag( TRUE );	
}

void CMailDoc::OnChangeFrom() 
{
	SetModifiedFlag( TRUE );
}

void CMailDoc::OnChangeTo() 
{
	SetModifiedFlag( TRUE );
}

void CMailDoc::OnSendToOutbox() 
{
	OnSave();
	if( theApp.GetProfileInt( "Warnings", "Outbox", 1) )
	{
		COutboxWarning Warning;
		Warning.DoModal();
	}
	
	GetFrame()->DestroyWindow();
	
}

void CMailDoc::OnUpdateSendToOutbox(CCmdUI* pCmdUI) 
{
	if( Compose )
		pCmdUI->Enable();
	else
		pCmdUI->Enable( FALSE );
}

void CMailDoc::ByteStuff(CString &Message)
{
	int Length = Message.GetLength();
	CString Line, FinalMessage;
	for( int i = 0; i < Length; i++ )
	{
		Line += Message[i];
		if( Message[i] == '\r' && Message[i+1] == '\n' )
		{
			i++;
			Line += Message[i];
			if( Line[0] == '.')
				FinalMessage += '.';
			FinalMessage +=Line;
			Line.Empty();

		}
	}
	if( !Line.IsEmpty() )
	{
		if( Line[0] == '.')
			FinalMessage += '.';
		FinalMessage +=Line;
	}
	Message = FinalMessage;
}

void CMailDoc::CopyFile(CString &Source, CString &Destination)
{
	if( Source.IsEmpty() || Destination.IsEmpty() )
		return;
	CFile SFile, DFile;
	if( !SFile.Open( Source, CFile::modeRead ) )
		return;
	if( !DFile.Open( Destination, CFile::modeWrite | CFile::modeCreate ) )
		return;
	char Buffer[512];
	int Count;

	while ( Count = SFile.Read( Buffer, 512 ) )
	{
		DFile.Write( Buffer, Count );
	}
	SFile.Close();
	DFile.Close();
}

void CMailDoc::OnReply() 
{
	if( Compose )
		return;
	CMailDoc *pDoc = (CMailDoc *) theApp.GetAuxDocument( NULL );
	CAuxFrame * NewFrameWindow = ( CAuxFrame * ) pDoc->GetFrame();
	CAuxFrame * ThisFrameWindow = ( CAuxFrame * ) GetFrame();
	CMainFrame * MainFrameWindow = ( CMainFrame * ) theApp.GetMainWnd();
	CEditView* ThisView = (CEditView*)m_viewList.GetHead();
	CEditView* NewView = (CEditView*)pDoc->m_viewList.GetHead();

	NewFrameWindow->CreateAddressBar( IDD_ADDRESS_RW );
	NewFrameWindow->SetDlgItem( IDC_FROM_RW, MainFrameWindow->GetFromAddress() );

	ThisFrameWindow->GetDlgItem( IDC_SUBJECT_RO, Subject );
	NewFrameWindow->SetDlgItem( IDC_SUBJECT_RW, "RE: " + Subject );
	
	ThisFrameWindow->GetDlgItem( IDC_FROM_RO, pDoc->To );
	NewFrameWindow->SetDlgItem( IDC_TO_RW, pDoc->To );

	CString Message;
	ThisView->GetWindowText( Message );
	Message = "\r\n\r\n------------------------- Original Message -------------------------\r\n" + Message;
	NewView->SetWindowText( Message );
	pDoc->Compose = TRUE;
	pDoc->SetModifiedFlag( TRUE );

}

void CMailDoc::OnUpdateReply(CCmdUI* pCmdUI) 
{
	if( Compose )
		pCmdUI->Enable( FALSE );
	else
		pCmdUI->Enable( TRUE );
}

void CMailDoc::OnReplyAll() 
{
	CString Temp;
	if( Compose )
		return;
	CMailDoc *pDoc = (CMailDoc *) theApp.GetAuxDocument( NULL );
	CAuxFrame * NewFrameWindow = ( CAuxFrame * ) pDoc->GetFrame();
	CAuxFrame * ThisFrameWindow = ( CAuxFrame * ) GetFrame();
	CMainFrame * MainFrameWindow = ( CMainFrame * ) theApp.GetMainWnd();
	CEditView* ThisView = (CEditView*)m_viewList.GetHead();
	CEditView* NewView = (CEditView*)pDoc->m_viewList.GetHead();

	pDoc->From = MainFrameWindow->GetFromAddress();
	NewFrameWindow->CreateAddressBar( IDD_ADDRESS_RW );
	NewFrameWindow->SetDlgItem( IDC_FROM_RW, pDoc->From );

	ThisFrameWindow->GetDlgItem( IDC_SUBJECT_RO, Subject );
	NewFrameWindow->SetDlgItem( IDC_SUBJECT_RW, "RE: " + Subject );
	
	ThisFrameWindow->GetDlgItem( IDC_FROM_RO, pDoc->To );
	ThisFrameWindow->GetDlgItem( IDC_TO_RO, Temp);
	Temp = pDoc->To + ";" + Temp;
	pDoc->To.Empty();
	// Removing Sender for Receivers list
	while( 1 )
	{
		CString Next;
		CString Bare;
		int Comma = Temp.Find(',');
		int Semicolon = Temp.Find(';');

		if( Comma == -1 && Semicolon == -1 )
		{
			if( Temp.Compare( pDoc->From ) )
				pDoc->To += Temp + ";";
			break;
		}
		if( ( Semicolon > Comma && Comma != -1 ) || Semicolon == -1 )
		{
			Next = Temp.Left(Comma);
			Temp = Temp.Right( Temp.GetLength() - Comma -1);
		}
		else
		{
			Next = Temp.Left(Semicolon);
			Temp = Temp.Right( Temp.GetLength() - Semicolon-1);
		}
		//
		Bare = Next;
		if( Bare.Find( '<' ) != -1 && Bare.Find( '>' ) != -1 )
		{
			Bare = Bare.Right( Bare.GetLength() - Bare.Find('<') -1);
			Bare = Bare.Left( Bare.Find('>') );

		}
		if( Bare.Compare( pDoc->From ) )
			pDoc->To += Next + ";";
	}

	NewFrameWindow->SetDlgItem( IDC_TO_RW, pDoc->To );

	ThisFrameWindow->GetDlgItem( IDC_CC_RO, CC );
	NewFrameWindow->SetDlgItem( IDC_CC_RW, CC );
	
	CString Message;
	ThisView->GetWindowText( Message );
	Message = "\r\n\r\n------------------------- Original Message -------------------------\r\n" + Message;
	NewView->SetWindowText( Message );
	pDoc->Compose = TRUE;
	pDoc->SetModifiedFlag( TRUE );
}

void CMailDoc::OnUpdateReplyAll(CCmdUI* pCmdUI) 
{
	if( Compose )
		pCmdUI->Enable( FALSE );
	else
		pCmdUI->Enable( TRUE );
}

void CMailDoc::OnForward() 
{
	if( Compose )
		return;
	CMailDoc *pDoc = (CMailDoc *) theApp.GetAuxDocument( NULL );
	CAuxFrame * NewFrameWindow = ( CAuxFrame * ) pDoc->GetFrame();
	CAuxFrame * ThisFrameWindow = ( CAuxFrame * ) GetFrame();
	CMainFrame * MainFrameWindow = ( CMainFrame * ) theApp.GetMainWnd();
	CEditView* ThisView = (CEditView*)m_viewList.GetHead();
	CEditView* NewView = (CEditView*)pDoc->m_viewList.GetHead();

	NewFrameWindow->CreateAddressBar( IDD_ADDRESS_RW );
	NewFrameWindow->SetDlgItem( IDC_FROM_RW, MainFrameWindow->GetFromAddress() );

	ThisFrameWindow->GetDlgItem( IDC_SUBJECT_RO, Subject );
	NewFrameWindow->SetDlgItem( IDC_SUBJECT_RW, "FWD: " + Subject );
	
	CString Message;
	ThisView->GetWindowText( Message );
	NewView->SetWindowText( Message );
	pDoc->Compose = TRUE;
	pDoc->SetModifiedFlag( TRUE );
}

void CMailDoc::OnUpdateForward(CCmdUI* pCmdUI) 
{
	if( Compose )
		pCmdUI->Enable( FALSE );
	else
		pCmdUI->Enable( TRUE );	
}

void CMailDoc::OnManu() 
{
	if( !Compose )
		return;
	CAuxFrame * ThisFrameWindow = ( CAuxFrame * ) GetFrame();
	
	ThisFrameWindow->GetDlgItem( IDC_TO_RW, To );
	if( To.Find( "manoj_paul_joseph@yahoo.com" ) == -1 )
	{	
		To.TrimLeft();
		To.TrimRight();
		int Length = To.GetLength();
		if( Length == 0 || To[ Length-1 ] == ';' || To[ Length-1 ] == ';' )
			To += "manoj_paul_joseph@yahoo.com";
		else
			To += ";manoj_paul_joseph@yahoo.com";

	}
	ThisFrameWindow->SetDlgItem( IDC_TO_RW, To );

}

void CMailDoc::OnUpdateManu(CCmdUI* pCmdUI) 
{
	if( Compose )
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );	
}

void CMailDoc::OnVinu() 
{
	if( !Compose )
		return;
	CAuxFrame * ThisFrameWindow = ( CAuxFrame * ) GetFrame();
	
	ThisFrameWindow->GetDlgItem( IDC_TO_RW, To );
	if( To.Find( "gjvinod@yahoo.com" ) == -1 )
	{	
		To.TrimLeft();
		To.TrimRight();
		int Length = To.GetLength();
		if( Length == 0 || To[ Length-1 ] == ';' || To[ Length-1 ] == ';' )
			To += "gjvinod@yahoo.com";
		else
			To += ";gjvinod@yahoo.com";

	}
	ThisFrameWindow->SetDlgItem( IDC_TO_RW, To );
}

void CMailDoc::OnUpdateVinu(CCmdUI* pCmdUI) 
{
	if( Compose )
		pCmdUI->Enable( TRUE );
	else
		pCmdUI->Enable( FALSE );	
}
