// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__830C65FB_5E1F_4F83_BBC4_C7F689EE584B__INCLUDED_)
#define AFX_MAINFRM_H__830C65FB_5E1F_4F83_BBC4_C7F689EE584B__INCLUDED_

#include "Mail.h"	// Added by ClassView
#include "MixFile.h"
#include "WelcomeDlg.h"	
#include "UserDlg.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CMainFrame : public CFrameWnd
{
friend class CTreePane;	
friend class CListPane;
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
protected:
	CSplitterWnd m_wndSplitter;
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	void Download( CMail * Mail);
	void OnMailSent( DWORD No, BOOL Success );

	BOOL ReadMailStore(CString &MailStore, CMailList *MailList);
	void OnMailReceipt(DWORD No);
	void OnHeaderReceipt(DWORD No, BOOL Done );
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;	
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;
//	CDialogBar	m_wndDialogBar;


// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnReceive();
	afx_msg void OnDownload();
	afx_msg void OnUpdateDownload(CCmdUI* pCmdUI);
	afx_msg void OnRead();
	afx_msg void OnUpdateRead(CCmdUI* pCmdUI);
	afx_msg void OnDisconnect();
	afx_msg void OnDelete();
	afx_msg void OnUpdateDelete(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDisconnect(CCmdUI* pCmdUI);
	afx_msg void OnUpdateReceive(CCmdUI* pCmdUI);
	afx_msg void OnNewMail();
	afx_msg void OnSend();
	afx_msg void OnUpdateSend(CCmdUI* pCmdUI);
	afx_msg void OnDownloadAll();
	afx_msg void OnUpdateDownloadAll(CCmdUI* pCmdUI);
	afx_msg void OnServers();
	afx_msg void OnUser();
	afx_msg void OnUpdateUser(CCmdUI* pCmdUI);
	afx_msg void OnUpdateServers(CCmdUI* pCmdUI);
	afx_msg void OnClose();
	afx_msg void OnViewSenddialogbox();
	afx_msg void OnUpdateViewSenddialogbox(CCmdUI* pCmdUI);
	afx_msg void OnViewReceivedialogbox();
	afx_msg void OnUpdateViewReceivedialogbox(CCmdUI* pCmdUI);
	afx_msg void OnReadSpecial();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	afx_msg LRESULT OnAddition(WPARAM, LPARAM);
public:
	CDocument * ReadSpecial( const char * Filename);
	void StopReceiveing();
	void StopSending();
	BOOL IsReceiving();
	BOOL IsSending();
	CString GetFromAddress();
	void OnSMTPQuit();
	void OnPOPQuit();
	void OnPOPAuthentication(BOOL Success);
	void OnSMTPAuthentication(BOOL Success);
	void OnMailDelete(DWORD No, BOOL Success);
	BOOL GetServers();
private:
	BOOL Authentication;
	CUserDlg UserDlg;

	CString POPServer;
	CString SMTPServer;
	CString Address;
	CString Username;
	CString Password;
	CWelcomeDlg WelcomeDlg;

	CDocument * ShowMail( const char * Filename);
	CDocument * ComposeMail( const char * Filename);
	CMailList *pMailList;
	CMailList *pInBox;
	CMailList *pOutBox;
	CMailList *pSentTo;
	CMailList *pDeleted;

	CArray<int ,int > DownloadList;
	CArray<int ,int > DeleteList;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__830C65FB_5E1F_4F83_BBC4_C7F689EE584B__INCLUDED_)
