#include "stdafx.h"
#include "Postman.h"
#include "Mail.h"
#include "MixFile.h"



BOOL CMixFile::WriteMIX( CString &MixFileName )
{
	CFile MixFile;
	CFile MixFileNew;
	char Buffer[512];
	CMail Mail;
	WORD TotalLength;
	WORD UIDLength;
	WORD FromLength;
	WORD ToLength;
	WORD DateLength;
	WORD SubLength;
	WORD FileNameLength;
	WORD Stat;

	CString TempFile = MixFileName + "temp";
	MixFile.Open(MixFileName, CFile::modeNoTruncate | CFile::modeCreate | CFile::modeRead );
	MixFileNew.Open(TempFile , CFile::modeCreate | CFile::modeWrite );
	while ( 1)
	{
			if( !MixFile.Read( &TotalLength, sizeof( WORD ) ) )
				break;

			MixFile.Read( &UIDLength, sizeof( WORD ) );
			MixFile.Read( Buffer, UIDLength);
			Mail.ID = Buffer;
	
			MixFile.Read( &FileNameLength, sizeof( WORD ) );
			MixFile.Read( Buffer, FileNameLength);
			Mail.FileName = Buffer;

			MixFile.Read( &FromLength, sizeof( WORD ) );
			MixFile.Read( Buffer, FromLength);
			Mail.From = Buffer;

			MixFile.Read( &ToLength, sizeof( WORD ) );
			MixFile.Read( Buffer, ToLength);
			Mail.To = Buffer;
		
			MixFile.Read( &SubLength, sizeof( WORD ) );
			MixFile.Read( Buffer, SubLength);
			Mail.Subject = Buffer;

			MixFile.Read( &DateLength, sizeof( WORD ) );
			MixFile.Read( Buffer, DateLength);
			Mail.Date = Buffer;
		
			MixFile.Read( & Mail.Size, sizeof( DWORD) );
			MixFile.Read( &Stat, sizeof( WORD) );
			if( Mail.FileName != FileName )
			{
				MixFileNew.Write( &TotalLength, sizeof( WORD ) );
			
				MixFileNew.Write( &UIDLength, sizeof( WORD ) );
				MixFileNew.Write( (LPCSTR) Mail.ID, UIDLength );
		
				MixFileNew.Write( &FileNameLength, sizeof( WORD ) );
				MixFileNew.Write( (LPCSTR) Mail.FileName, FileNameLength);
		
				MixFileNew.Write( &FromLength, sizeof( WORD ) );
				MixFileNew.Write( (LPCSTR) Mail.From, FromLength);

				MixFileNew.Write( &ToLength, sizeof( WORD ) );
				MixFileNew.Write( (LPCSTR) Mail.To, ToLength);
		
				MixFileNew.Write( &SubLength, sizeof( WORD ) );
				MixFileNew.Write( (LPCSTR) Mail.Subject, SubLength);
		
				MixFileNew.Write( &DateLength, sizeof( WORD ) );
				MixFileNew.Write( (LPCSTR) Mail.Date, DateLength);
		
				MixFileNew.Write( & Mail.Size, sizeof( DWORD) );
				MixFileNew.Write( & Stat, sizeof( WORD) );
			}
	}

	UIDLength = UID.GetLength() + 1;
	FromLength = From.GetLength() + 1;
	ToLength = To.GetLength() + 1;
	DateLength = Date.GetLength() + 1;
	SubLength = Subject.GetLength() + 1;
	FileNameLength = FileName.GetLength() + 1;
	TotalLength = UIDLength + FromLength + DateLength + ToLength +
			SubLength + FileNameLength + sizeof( DWORD ) + ( 7 * sizeof( WORD ) );


	MixFileNew.Write( &TotalLength, sizeof( WORD ) );
			
	MixFileNew.Write( &UIDLength, sizeof( WORD ) );
	MixFileNew.Write( (LPCSTR) UID, UIDLength );
		
	MixFileNew.Write( &FileNameLength, sizeof( WORD ) );
	MixFileNew.Write( (LPCSTR) FileName, FileNameLength);
		
	MixFileNew.Write( &FromLength, sizeof( WORD ) );
	MixFileNew.Write( (LPCSTR) From, FromLength);

	MixFileNew.Write( &ToLength, sizeof( WORD ) );
	MixFileNew.Write( (LPCSTR) To, ToLength);
	
	MixFileNew.Write( &SubLength, sizeof( WORD ) );
	MixFileNew.Write( (LPCSTR) Subject, SubLength);
		
	MixFileNew.Write( &DateLength, sizeof( WORD ) );
	MixFileNew.Write( (LPCSTR) Date, DateLength);
		
	MixFileNew.Write( & Size, sizeof( DWORD) );
	MixFileNew.Write( & Status, sizeof( WORD) );
	MixFileNew.Close( );
	MixFile.Close();
	_unlink( MixFileName );
	rename( TempFile, MixFileName );
	return TRUE;
}

BOOL CMixFile::ReadMIX( CString & Folder, CMailList * MailList )
{
	CFile MixFile;
	CMail Mail;
	CMail * NewMail;
	char Buffer[512];
	WORD TotalLength = 0, UIDLength, FromLength, ToLength, SubLength, DateLength, FileNameLength, Status = 0;
	if( Folder[ Folder.GetLength() - 1 ] != '\\' )
		Folder += '\\';
	CString Parent = Folder + "Mail Index.mix";
	CString Size;
	
	#ifdef _DEBUG
		CString Msg;
	#endif

	CFileException fe;
	try
	{
		if( !MixFile.Open( Parent, CFile::modeRead , &fe) )
			return 0;
		while ( 1)
		{
			if( !MixFile.Read( &TotalLength, sizeof( WORD ) ) )
				break;
		
			MixFile.Read( &UIDLength, sizeof( WORD ) );
			MixFile.Read( Buffer, UIDLength);
			Mail.ID = Buffer;
	
			MixFile.Read( &FileNameLength, sizeof( WORD ) );
			MixFile.Read( Buffer, FileNameLength);
			Mail.FileName = Buffer;

			MixFile.Read( &FromLength, sizeof( WORD ) );
			MixFile.Read( Buffer, FromLength);
			Mail.From = Buffer;

			MixFile.Read( &ToLength, sizeof( WORD ) );
			MixFile.Read( Buffer, ToLength);
			Mail.To = Buffer;
		
			MixFile.Read( &SubLength, sizeof( WORD ) );
			MixFile.Read( Buffer, SubLength);
			Mail.Subject = Buffer;

			MixFile.Read( &DateLength, sizeof( WORD ) );
			MixFile.Read( Buffer, DateLength);
			Mail.Date = Buffer;
		
			MixFile.Read( & Mail.Size, sizeof( DWORD) );
			MixFile.Read( & Status, sizeof( WORD) );
			CFileStatus FileStatus;
			
			if( CFile::GetStatus( Mail.FileName, FileStatus) )
			{
				NewMail = MailList->AddMail( );
				NewMail->Date = Mail.Date;
				NewMail->From = Mail.From;
				NewMail->To = Mail.To;
				NewMail->ID = Mail.ID;
				NewMail->Size = Mail.Size;
				NewMail->Subject = Mail.Subject;
				NewMail->FileName = Mail.FileName;
			}
			else
			{
				#ifdef _DEBUG
				Msg += Mail.FileName + "\r\n";

				#endif
			}
		}
		
		#ifdef _DEBUG
		if( !Msg.IsEmpty() )
		{
			AfxMessageBox ( Msg );
		}
		#endif
		MixFile.Close( );
	}
	catch(...)
	{
		AfxMessageBox("Exception caught");		
	}
	return TRUE;
}

void CMixFile::DeleteFile(CString FileName)
{
	CString Folder = FileName.Left( FileName.ReverseFind( '\\' ) );	
	CString MixFileName = Folder + "\\Mail Index.mix";
	CFile MixFile;
	CFile MixFileNew;
	char Buffer[512];
	CMail Mail;
	WORD TotalLength;
	WORD UIDLength;
	WORD FromLength;
	WORD ToLength;
	WORD DateLength;
	WORD SubLength;
	WORD FileNameLength;
	WORD Stat;

	CString TempFile = MixFileName + "temp";
	MixFile.Open(MixFileName, CFile::modeNoTruncate | CFile::modeCreate | CFile::modeRead );
	MixFileNew.Open(TempFile , CFile::modeCreate | CFile::modeWrite );
	while ( 1)
	{
			if( !MixFile.Read( &TotalLength, sizeof( WORD ) ) )
				break;

			MixFile.Read( &UIDLength, sizeof( WORD ) );
			MixFile.Read( Buffer, UIDLength);
			Mail.ID = Buffer;
	
			MixFile.Read( &FileNameLength, sizeof( WORD ) );
			MixFile.Read( Buffer, FileNameLength);
			Mail.FileName = Buffer;

			MixFile.Read( &FromLength, sizeof( WORD ) );
			MixFile.Read( Buffer, FromLength);
			Mail.From = Buffer;

			MixFile.Read( &ToLength, sizeof( WORD ) );
			MixFile.Read( Buffer, ToLength);
			Mail.To = Buffer;
		
			MixFile.Read( &SubLength, sizeof( WORD ) );
			MixFile.Read( Buffer, SubLength);
			Mail.Subject = Buffer;

			MixFile.Read( &DateLength, sizeof( WORD ) );
			MixFile.Read( Buffer, DateLength);
			Mail.Date = Buffer;
		
			MixFile.Read( & Mail.Size, sizeof( DWORD) );
			MixFile.Read( &Stat, sizeof( WORD) );
			if( Mail.FileName != FileName )
			{
				MixFileNew.Write( &TotalLength, sizeof( WORD ) );
			
				MixFileNew.Write( &UIDLength, sizeof( WORD ) );
				MixFileNew.Write( (LPCSTR) Mail.ID, UIDLength );
		
				MixFileNew.Write( &FileNameLength, sizeof( WORD ) );
				MixFileNew.Write( (LPCSTR) Mail.FileName, FileNameLength);
		
				MixFileNew.Write( &FromLength, sizeof( WORD ) );
				MixFileNew.Write( (LPCSTR) Mail.From, FromLength);

				MixFileNew.Write( &ToLength, sizeof( WORD ) );
				MixFileNew.Write( (LPCSTR) Mail.To, ToLength);
		
				MixFileNew.Write( &SubLength, sizeof( WORD ) );
				MixFileNew.Write( (LPCSTR) Mail.Subject, SubLength);
		
				MixFileNew.Write( &DateLength, sizeof( WORD ) );
				MixFileNew.Write( (LPCSTR) Mail.Date, DateLength);
		
				MixFileNew.Write( & Mail.Size, sizeof( DWORD) );
				MixFileNew.Write( & Stat, sizeof( WORD) );
			}
	}
	MixFileNew.Close( );
	MixFile.Close();
	_unlink( MixFileName );
	rename( TempFile, MixFileName );
}
