// SMTPSocket.cpp : implementation file
//

#include "stdafx.h"
#include "Postman.h"
#include "SMTPSocket.h"
#include "Postman.h"
#include "Mail.h"
#include "States.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSMTPSocket


CSMTPSocket::CSMTPSocket(CMailList * pML, CSndRecvDlg *DlgBox)
{
	DialogBox = DlgBox;
	pMailList = pML;
	State = NOTCONNECTED;
	TotalSize = 0;
	BytesSent = 0;
}

CSMTPSocket::~CSMTPSocket()
{
	if( State != NOTCONNECTED )
	{
		State = NOTCONNECTED;
		Close();
	}
}


// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CSMTPSocket, CAsyncSocket)
	//{{AFX_MSG_MAP(CSMTPSocket)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// CSMTPSocket member functions

void CSMTPSocket::OnConnect(int nErrorCode) 
{
	CString Message("Connection established with SMTP server.");
	DialogBox->SetHeader( Message );
	State = CONNECTED;
	CAsyncSocket::OnConnect(nErrorCode);
	BytesSent = 0;
	DialogBox->m_Progress.SetPos(0);
}

void CSMTPSocket::OnReceive(int nErrorCode) 
{
	CString Message;
	CString NextDataLine;
	DWORD Argument = 0;
	long Length = 0;
	IOCtl(FIONREAD, &Argument);
	if( Argument )
	{
		{
			//Recevie data after alocating memory...
			BYTE * pData = NULL;
			pData = (BYTE *)malloc( Argument + 1);
			Length = Receive( pData, Argument );
			if( Length == -1 )
				Length = 0;
			pData[Length] = 0;	//Adding a NULL character
			DataStore += pData;
			free( pData );
		}
		while( 1 )
		{
			//Extracting the next line if any...
			BOOL LineComplete = FALSE;
			NextDataLine.Empty();
			Length = DataStore.GetLength();
			for( int i = 0; i < Length; i++ )
			{
				NextDataLine += DataStore[i];
				if( i > 0 && DataStore[i] == '\n' && DataStore[i-1] == '\r' )
				{
					//Found a complete Line
					DataStore = DataStore.Right( Length - i - 1);
					LineComplete = TRUE;
					break;
				}
			}
			if( !LineComplete )
				break;
			Message = "SMTP S: " ;
			Message += NextDataLine;
			DialogBox->AddToStatus( Message );
			Length = NextDataLine.GetLength();
			if( State == CONNECTED )
			{
				if( NextDataLine[0] == '2' ) 
				{
					DialogBox->SetHeader( "Greeting received..." );
					// Greeting 220 received...
					// Sending HELLO Greeting...
					Message = "HELO Manoj\r\n";
					Send( (LPCSTR) Message, Message.GetLength() );
					Message = "C:" + Message;
					DialogBox->AddToStatus( Message );
					State = HELO;
					pMailList->ReadInMail( );
					
				}
				else if( NextDataLine[0] == '4' ) 
				{
					Length = NextDataLine.GetLength() - 3;
					if( Length > 0 )
						Message = NextDataLine.Right(Length );
					else
						Message = "Connection declined...";
					DialogBox->SetHeader( Message );
					AfxMessageBox(Message);
					//AfxMessageBox( "");
					ShutDown(receives);
					//Close();
					//DialogBox->DestroyWindow();
					State = NOTCONNECTED;
				}
				else
				{
					Length = NextDataLine.GetLength() - 3;
					if( Length > 0 )
						Message = NextDataLine.Right(Length );
					else
						Message = "Invalid greeting";
					DialogBox->SetHeader( Message );
					AfxMessageBox(Message);
//					AfxMessageBox( "Invalid greeting");
					ShutDown(receives);
					//Close();
					DialogBox->DestroyWindow();
					State = NOTCONNECTED;
				}
			}
			else if ( State == HELO )
			{
				if( NextDataLine[0] == '2' ) 
				{
					// Response 250 received...
					//Sending MAIL message
					//::MessageBox( NULL, "Waiting", "Authentication Done", MB_OK);
					pMailList->OnSMTPAuthentication( TRUE );
					SendMail();
				}
				else
				{
					Length = NextDataLine.GetLength() - 3;
					if( Length > 0 )
						Message = NextDataLine.Right(Length );
					else
						Message = "Greeting rejected...";
					DialogBox->SetHeader( Message );
					AfxMessageBox(Message);

					DialogBox->DestroyWindow();
					pMailList->OnSMTPAuthentication( FALSE );
					//Close();
					ShutDown(receives);
					State = NOTCONNECTED;
				}
			}
			else if ( State == MAIL )
			{
				if( NextDataLine[0] == '2' ) 
				{
					// Response 250 received...
					//Sending RCPT message
					CString NextRecipient = GetNextRecipient();
					Message = "RCPT TO:" + NextRecipient + "\r\n";
					Send( (LPCSTR) Message, Message.GetLength() );
					Message = "C:" + Message;
					DialogBox->AddToStatus( Message );
					State = RCPT;
				}
				else
				{
					Length = NextDataLine.GetLength() - 3;
					if( Length > 0 )
						Message = NextDataLine.Right(Length );
					else
						Message = "Sender rejected...";
					if( NextDataLine[1] == '5' ) 
					{
						Message = "FAILURE : " + Message;
					}
					else
					{
						Message = "ERROR : " + Message;
					}
					DialogBox->SetHeader( Message );
					AfxMessageBox(Message);
					State = SMTPIDLE;
					
					pMailList->OnMailSent( MailNo, FALSE );
				}
			}
			else if ( State == RCPT )
			{
				if( NextDataLine[0] == '2' ) 
				{
					// Response 250/251 received...
					CString NextRecipient = GetNextRecipient();
					if( NextRecipient.GetLength() )
					{
						Message = "RCPT TO:" + NextRecipient + "\r\n";
						Send( (LPCSTR) Message, Message.GetLength() );
						Message = "C:" + Message;
						DialogBox->AddToStatus( Message );
						State = RCPT;
					}
					else
					{
						// Sending DATA message...
						Message = "DATA\r\n";
						Send( (LPCSTR) Message, Message.GetLength() );
						Message = "C: DATA";
						DialogBox->AddToStatus( Message );
						State = DATA1;
					}
				}
				else
				{
					Length = NextDataLine.GetLength() - 3;
					if( Length > 0 )
						Message = NextDataLine.Right(Length );
					else
						Message = "Receiver rejected...";
					if( NextDataLine[1] == '5' ) 
					{
						Message = "FAILURE : " + Message;
					}
					else
					{
						Message = "ERROR : " + Message;
					}
					DialogBox->SetHeader( Message );
					AfxMessageBox(Message);
					
					State = SMTPIDLE;
					pMailList->OnMailSent( MailNo, FALSE );
				}
			}
			else if ( State == DATA1 )
			{
				if( NextDataLine[0] == '3' ) 
				{
					// Response 354 received...
					// Sending the message data...
					Send( (LPCSTR) m_Message, m_Message.GetLength() );
					Message = "C:" + m_Message;
					DialogBox->AddToStatus( Message );
					State = DATA2;
				}
				else
				{
					Length = NextDataLine.GetLength() - 3;
					if( Length > 0 )
						Message = NextDataLine.Right(Length );
					else
						Message = "DATA messaage rejected...";

					if( NextDataLine[1] == '5' ) 
					{
						Message = "FAILURE : " + Message;
					}
					else
					{
						Message = "ERROR : " + Message;
					}
					DialogBox->SetHeader( Message );
					AfxMessageBox(Message);
					ShutDown(receives);
					//Close();
					State = NOTCONNECTED;
				}
			}
			else if ( State == DATA2 )
			{
				if( NextDataLine[0] == '2' ) 
				{
					// Response 250 received...
					//Message sent successfully
					BytesSent += m_Message.GetLength();
					if( TotalSize )
						DialogBox->m_Progress.SetPos( BytesSent * 100 / TotalSize );
				}
				else
				{
					Length = NextDataLine.GetLength() - 3;
					if( Length > 0 )
						Message = NextDataLine.Right(Length );
					else
						Message = "Message rejected...";

					if( NextDataLine[1] == '5' ) 
					{
						Message = "FAILURE : " + Message;
					}
					else
					{
						Message = "ERROR : " + Message;
					}
					DialogBox->SetHeader( Message );
					AfxMessageBox(Message);

				}
				State = SMTPIDLE;
				pMailList->OnMailSent( MailNo );
			}
			else if ( State == QUIT )
			{
				if( NextDataLine[0] == '2' && NextDataLine[1] == '2' && NextDataLine[2] == '1' ) 
				{
					State = NOTCONNECTED;
					ShutDown(receives);
					//Close();
					AfxMessageBox("Done sending");
					pMailList->OnSMTPQuit();
					if( IsWindow( DialogBox->m_hWnd ) )
					{
						DialogBox->SetHeader( "Done Sending");
						DialogBox->ShowWindow( SW_HIDE );
					}

				}
				else if( NextDataLine[0] == '5' && NextDataLine[1] == '0' && NextDataLine[2] == '0'  ) 
				{
					State = NOTCONNECTED;
					Length = NextDataLine.GetLength() - 3;
					if( Length > 0 )
						Message = NextDataLine.Right(Length );
					else
						Message = "QUIT Messaage rejected...";
					AfxMessageBox( Message );
					//Close();
					ShutDown(receives);
					pMailList->OnSMTPQuit();
				}
				else
				{
					Message = "Invalid response : " + NextDataLine;
					DialogBox->SetHeader( Message );
					AfxMessageBox( "Received something otherthan a valid QUIT response" );
				}
			}
		}
	}
}

void CSMTPSocket::OnClose(int nErrorCode) 
{
	if( State == QUIT )
	{
		State = NOTCONNECTED;
		AfxMessageBox("Done sending");
		pMailList->OnSMTPQuit();
		if( IsWindow( DialogBox->m_hWnd ) )
		{
			DialogBox->SetHeader( "Done Sending");
			DialogBox->ShowWindow( SW_HIDE );
		}
	}
	else
	{
		CString Message("Connection with SMTP server terminated.");
		pMailList->OnSMTPAuthentication( FALSE );
		DialogBox->SetHeader( Message );
		Close();
	}
}


void CSMTPSocket::SendMail()
{
	DialogBox->SetHeader("Sending Mail...");
	State = MAIL;
	CString Message = "MAIL FROM:" + m_From + "\r\n";
	DialogBox->SetHeader( "Sending mail...");
	DialogBox->m_Count.Empty();
	DialogBox->UpdateData( FALSE );
	Send( (LPCSTR) Message, Message.GetLength() );
	Message = "C:" + Message;
	DialogBox->AddToStatus( Message );
	InitialiseRecipients();	
}

void CSMTPSocket::Quit()
{
	// Sending QUIT message...
	State = QUIT;
	CString Message = "QUIT\r\n";
	Send( (LPCSTR) Message, Message.GetLength() );
	Message = "C:" + Message;
	DialogBox->AddToStatus( Message );
	DialogBox->SetHeader( "Quitting...");
	DialogBox->m_Count.Empty();
	DialogBox->UpdateData( FALSE );
}

void CSMTPSocket::InitialiseRecipients()
{
	char EndChar;
	Recipients = m_To;
	Recipients.TrimRight();
	EndChar = Recipients[ Recipients.GetLength() - 1 ];
	if( EndChar == ',' || EndChar == ';' )
	{
		Recipients += m_CC;
	}
	else
		Recipients += ";" + m_CC;
	
}

CString CSMTPSocket::GetNextRecipient()
{

	Recipients.TrimRight();
	Recipients.TrimLeft();
	CString Next = Recipients;
	int Length = Recipients.GetLength();
	if( Length == 0 )
		return Next;

	int Comma = Recipients.Find(',');
	int Semicolon = Recipients.Find(';');
	if( Comma == -1 && Semicolon == -1 )
	{
		Recipients.Empty();
		return Next;
	}
	if( ( Semicolon > Comma && Comma != -1 ) || Semicolon == -1 )
	{
		Next = Recipients.Left(Comma);
		Recipients = Recipients.Right( Length - Comma -1);
	}
	else
	{
		Next = Recipients.Left(Semicolon);
		Recipients = Recipients.Right( Length - Semicolon-1);
	}
	return Next;
}
